<template>
  <div>
    <input
      :type="type"
      :class="componentClasses"
      :placeholder="placeholder"
      :disabled="disabled"
      :value="value"
      data-testid="input"
      @input="$emit('input', $event.target.value)"
    />
  </div>
</template>

<script>
export default {
  name: 'SaInputField',
  props: {
    type: {
      type: String,
      default: 'text'
    },
    placeholder: {
      type: String,
      default: null
    },
    size: {
      type: String,
      default: 'regular'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    inError: {
      type: Boolean,
      default: false
    },
    value: {
      type: String,
      default: ''
    }
  },
  computed: {
    componentClasses() {
      const classes = ['input', this.size]
      if (this.inError) {
        classes.push('error')
      }
      if (this.disabled) {
        classes.push('disabled')
      }
      return classes
    }
  }
}
</script>

<style lang="scss" scoped></style>
